%{!?luaver: %global luaver %(lua -e "print(string.sub(_VERSION, 5))")}
%if 0%{?rhel} <= 6
%global luanext 5.2
%endif

%global luapkgdir %{_datadir}/lua/%{luaver}

%if 0%{?el5}
# For some reason find-debuginfo.sh is still triggered on RHEL 5, despite
# BuildArch being noarch -- the script then fails. Explicitly disable it
%global debug_package %{nil}
%endif

Name:           luarocks
Version:        2.0.13
Release:        1%{?dist}
Summary:        A deployment and management system for Lua modules

License:        MIT
%if 0%{?rhel}
# RHEL 5's rpm requires this field
# RHEL 6's rpmlint warns if it is unspecified
Group:          Development/Tools
%endif
URL:            http://luarocks.org
Source0:        http://luarocks.org/releases/luarocks-%{version}.tar.gz

BuildArch:      noarch
%if 0%{?el5}
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%endif

BuildRequires:  lua-devel
%if ! 0%{?rhel} <= 6
Requires:       lua(abi) = %{luaver}
%else # for RHEL 5 and 6
Requires:       lua >= %{luaver}
Requires:       lua <  %{luanext}
%endif

%description
LuaRocks allows you to install Lua modules as self-contained packages
called "rocks", which also contain version dependency
information. This information is used both during installation, so
that when one rock is requested all rocks it depends on are installed
as well, and at run time, so that when a module is required, the
correct version is loaded. LuaRocks supports both local and remote
repositories, and multiple local rocks trees.


%prep
%setup -q
# Remove DOS line endings
for file in COPYING_7z; do
 sed "s|\r||g" $file > $file.new && \
 touch -r $file $file.new && \
 mv $file.new $file
done


%build
./configure --prefix=%{_prefix}
#{?_smp_mflags} -- luarocks makefile is not thread-safe
make


%install
%if 0%{?el5}
rm -rf $RPM_BUILD_ROOT
%endif
make install DESTDIR=$RPM_BUILD_ROOT
# fix symlinks to versioned binaries
for f in luarocks{,-admin};
do
  mv -f $RPM_BUILD_ROOT%{_bindir}/$f{-%{luaver},}
done


%check
# TODO - find how to run this without having to pre-download entire rocks tree
# ./test/run_tests.sh


%files
%doc COPYING* README.md
%dir %{_sysconfdir}/luarocks
%config(noreplace) %{_sysconfdir}/luarocks/config-%{luaver}.lua
%{_bindir}/luarocks
%{_bindir}/luarocks-admin
%{luapkgdir}/luarocks


%changelog
* Mon Apr 22 2013 Michel Salim <salimma@fedoraproject.org> - 2.0.13-1
- Update to 2.0.13

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Nov  5 2012 Michel Salim <salimma@fedoraproject.org> - 2.0.12-1
- Update to 2.0.12

* Fri Sep 28 2012 Michel Salim <salimma@fedoraproject.org> - 2.0.11-1
- Update to 2.0.11

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.8-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri May 11 2012 Michel Salim <salimma@fedoraproject.org> - 2.0.8-2
- Add support for RHEL's older lua packaging

* Tue May  8 2012 Michel Salim <salimma@fedoraproject.org> - 2.0.8-1
- Initial package
